diff -urN asterisk-1.2.7.1/channels/chan_iax2.c asterisk-1.2.7.1-work/channels/chan_iax2.c
--- asterisk-1.2.7.1/channels/chan_iax2.c	2006-04-01 03:11:26.000000000 +0800
+++ asterisk-1.2.7.1-work/channels/chan_iax2.c	2006-06-13 16:50:23.000000000 +0800
@@ -7475,8 +7475,17 @@
 				try_transfer(iaxs[fr.callno], &ies);
 				break;
 			case IAX_COMMAND_TXCNT:
-				if (iaxs[fr.callno]->transferring)
+				if (iaxs[fr.callno]->transferring) {
+					/* Change transfer address to where this packet came from (if it doesn't match the one given by TXREQ) */
+					/* And resend a TXCNT to this new address, if we haven't already received a TXACC */ 
+					if (inaddrcmp(&sin, &iaxs[fr.callno]->transfer)) {
+						iaxs[fr.callno]->transfer.sin_addr = sin.sin_addr;
+						iaxs[fr.callno]->transfer.sin_port = sin.sin_port;
+						if (iaxs[fr.callno]->transferring == TRANSFER_BEGIN) 
+							try_transfer(iaxs[fr.callno], &ies);
+					}
 					send_command_transfer(iaxs[fr.callno], AST_FRAME_IAX, IAX_COMMAND_TXACC, 0, NULL, 0);
+				}
 				break;
 			case IAX_COMMAND_TXREL:
 				/* Send ack immediately, rather than waiting until we've changed addresses */
